<template>
  <v-card class="auth elevation-0">
    <v-row
      justify="center"
      align="center"
    >
      <v-col cols="6" lg="5">
        <v-card-title
          class="px-0 blue-grey-text text-darken-4"
        >
          Авторизация
        </v-card-title>
        <v-form
          ref="form"
          v-model="valid"
          :lazy-validation="lazy"
        >
          <v-text-field
            v-model="email"
            name="email"
            :rules="emailRules"
            label="E-mail"
            required
          />
          <v-text-field
            v-model="password"
            type="password"
            :rules="passwordRules"
            label="Пароль"
            required
          />
          <v-btn
            color="success"
            class="mt-6"
            @click="login"
          >
            Войти
          </v-btn>
          <v-btn
            color="blue-grey darken-4"
            dark
            class="mt-6 ml-4"
            :to="{ name: 'Registration' }"
          >
            Регистрация
          </v-btn>
        </v-form>
      </v-col>
    </v-row>
  </v-card>
</template>

<script>
import api from '@/api';
import { mapState, mapActions } from 'vuex'

export default {
  name: 'AuthPage',
  data: () => ({
    valid: true,
    password: '',
    email: '',
    emailRules: [
      v => !!v || 'Необходимо заполнить',
      v => /.+@.+\..+/.test(v) || 'Некорректный Email',
    ],
    passwordRules: [
       v => !!v || 'Необходимо заполнить',
    ],
    lazy: false,
    errorText: '',
  }),
  created() {
    this.clearTokens();
  },
  methods: {
    ...mapActions('user', ['clearTokens']),
    async login() {
      if (!this.valid) return;
    
      const { err } = await api.common.login({
        email: this.email,
        password: this.password
      });
 
      if (err) {
        this.errorText = err;
        return;
      }
      
      this.$router.push({ name: 'Home' })
    },
  },
}
</script>

<style lang="stylus" scoped>
.auth {
  height 100%
  display flex
  align-items center
}
</style>
